QGIS Application - Bug report #6413
Support SLD with multiple FeatureTypeStyles
2012-09-26 02:41 AM - dr -

Status: Closed

Priority: Normal

Assignee:

Category: Symbology

Affected QGIS version:master Regression?: No
Operating System: Easy fix?: No
Pull Request or Patch supplied: Resolution:

Crashes QGIS or corrupls data: Copied to github as #: 15665
Description

| have the following SLD description:

<StyledLayerDescriptor version="1.0.0" xmIns:xlink="http://www.w3.0rg/1999/xlink" xmins:ogc="http://www.opengis.net/ogc"
xmins="http://www.opengis.net/sld">

<NamedLayer>

<Name>test</Name>

<UserStyle>

<Name>test</Name>

<FeatureTypeStyle>

<Rule>

<LineSymbolizer>

<Stroke>

<CssParameter name="stroke-width">4</CssParameter>
<CssParameter name="stroke">#dddddd</CssParameter>
</Stroke>

</LineSymbolizer>

</Rule>

</FeatureTypeStyle>

<FeatureTypeStyle>

<Rule>

<PolygonSymbolizer>

<Fill>

<CssParameter name="fill">#fa5000</CssParameter>
</Fill>

</PolygonSymbolizer>

</Rule>

</FeatureTypeStyle>

</UserStyle>

</NamedLayer>

</StyledLayerDescriptor>

When | try to render layer using this SLD by GeoServer | get expected result. In QGIS result is strange, it looks like QGIS doesn't support
multiple Feature TypeStyles sections within one SLD.

Associated revisions

Revision c49a18c5 - 2018-05-31 10:51 AM - Roel Huybrechts
Add support for reading SLD's with multiple Feature TypeStyle elements.

Introduce a virtual Feature TypeStyle to add support for reading SLD documents with more than one FeatureTypeStyle element.

Still supports SLD's with one FeatureTypeStyle, as well as SLD's with multiple Feature TypeStyles, including empty Feature TypeStyles (not breaking single
symbol rendering in that case). Complies with SLD's painter's model for rendering, appending Rules from subsequent Feature TypeStyles in order.

Fix #6413 (http://hub.qgis.org/issues/6413)

History

#1 - 2012-09-26 03:42 AM - Giuseppe Sucameli
- Priority changed from High to Normal

SLD docs containing multiple Feature TypeStyle are not supported yet.

#2 - 2012-12-31 01:23 AM - Paolo Cavallini

- Assignee changed from Giuseppe Sucameli to anonymous -

#3 - 2013-07-12 03:41 PM - Jiirgen Fischer
- Assignee deleted (anonymous -)

#4 - 2014-06-28 07:42 AM - Jiirgen Fischer
- Target version changed from Version 2.0.0 to Future Release - Lower Priority

#5 - 2015-02-09 12:46 PM - Roel Huybrechts

| added support for this in Github pull request 1894: https://github.com/qgis/QGIS/pull/1894

I'm open to comments and improvements here as well as on the Github page.

#6 - 2017-04-05 07:40 AM - Luigi Pirelli

confirmed that PR fix the error. The imported sld is converted in rule based with a rule for each FeatureStyle.

tested on 2.18 €35939

#7 - 2017-04-05 07:54 AM - Luigi Pirelli

approved the PR, can be merged to fix.

Would be necessary to port the PR to QGIS3

#8 - 2017-05-01 01:09 AM - Giovanni Manghi

- Regression? set to No

- Easy fix? set to No

#9 - 2017-10-14 11:53 AM - Andrea Aime
http://hub.qgis.org/issues/6413
https://github.com/qgis/QGIS/pull/1894

- Description updated

Hi Luigi, any reason why this ticket is still open?

#10 - 2017-10-16 12:35 PM - Giovanni Manghi

- Status changed from Open to Feedback

#11 - 2018-02-22 01:05 PM - Giovanni Manghi

- Status changed from Feedback to Open

- Pull Request or Patch supplied changed from No to Yes

Andrea Aime wrote:

Hi Luigi, any reason why this ticket is still open?

it seems the PR misses a unit test.

#12 - 2018-05-31 11:25 AM - Roel Huybrechts
- % Done changed from 0 to 100
- Status changed from Open to Closed

Applied in changeset commit:qgis|c49a18c587b660779276ebeff1d1a4f2011645df.
